Attribute VB_Name = "MdlGame"
Dim FormAct As Form
Dim Iteration As Currency
Public Sub Main()
    ResizeTerrain 100, 100
    
    FrmCmd.Show
    FrmLarge.Show
    FrmLoupe.Show
    FrmTaskBar.Show
    
    DoEvents
    
    FrmLoupe.Move 0, 0, Screen.TwipsPerPixelX * 16 * 32, Screen.TwipsPerPixelY * 16 * 32
    FrmCmd.Move 0, FrmLoupe.Height
    FrmLarge.Move FrmLoupe.Width, 0, Screen.TwipsPerPixelX * 10 * 32, Screen.TwipsPerPixelY * 32 * 12
End Sub
Public Sub Quit(ByRef Cancel As Integer)
Static Run As Boolean
    If Run Then Exit Sub
    Run = True
    If MsgBox("Voulez-vous quitter l'application ?", vbQuestion + vbYesNo, "Quitter ?") = vbNo Then
        Cancel = 1
    Else
        Unload FrmCmd
        Unload FrmLarge
        Unload FrmLoupe
        End
    End If
    Run = False
End Sub
Public Sub RefreshMoov()
    For X = 0 To UBound(Cells, 1)
        For Y = 0 To UBound(Cells, 2)
            a = 0
            For X1 = -1 To 1
                For Y1 = -1 To 1
                    If X1 <> 0 Or Y1 <> 0 Then
                        If Not (X1 + X > UBound(Cells, 1) Or X1 + X < LBound(Cells, 1) Or Y1 + Y > UBound(Cells, 2) Or Y1 + Y < LBound(Cells, 2)) Then
                            If Cells(X + X1, Y + Y1).Nouveau = True Then a = a + 1
                        End If
                    End If
                Next
            Next
            If a = 2 Then
                Cells(X, Y).Ancien = Cells(X, Y).Nouveau
            ElseIf a = 3 Then
                Cells(X, Y).Ancien = True
            Else
                Cells(X, Y).Ancien = False
            End If
        Next
    Next
    a = 0
    For X = 0 To UBound(Cells, 1)
        For Y = 0 To UBound(Cells, 2)
            Cells(X, Y).Nouveau = Cells(X, Y).Ancien
            If Cells(X, Y).Nouveau = True Then a = a + 1
        Next
    Next
    Iteration = Iteration + 1
    FrmCmd.LblCount.Caption = Replace(FrmCmd.LblCount.Tag, "%1", a)
    FrmCmd.LblIte.Caption = Replace(FrmCmd.LblIte.Tag, "%1", Iteration)
    
    If a = 0 Then ClearCell: FrmCmd.Timer1.Enabled = False
    RefreshEcr
End Sub
Public Sub RefreshEcr()
    FrmLarge.Form_Paint
    FrmLoupe.RefreshTerrain
End Sub
Public Sub RandomCell()
    a = (UBound(Cells, 1) + 1) * (UBound(Cells, 2) + 1) / 4
    
    Randomize Timer
    
    For i = 1 To a
        X1 = Int(Rnd * (UBound(Cells, 1)))
        Y1 = Int(Rnd * (UBound(Cells, 2)))
        
        X = X1 + 1
        Y = Y1
        If X > UBound(Cells, 1) Then X = 0: Y = Y + 1
        Do While Cells(X, Y).Nouveau
            X = X + 1
            If X > UBound(Cells, 1) Then X = 0: Y = Y + 1
            If Y > UBound(Cells, 2) Then Y = 0
            If X = X1 And Y = Y1 Then ClearCell: RandomCell: Exit Sub
        Loop
        
        Cells(X, Y).Nouveau = True
    Next
    RefreshEcr
End Sub
Public Sub ClearCell()
    For X = 0 To UBound(Cells, 1)
        For Y = 0 To UBound(Cells, 2)
            Cells(X, Y).Ancien = False
            Cells(X, Y).Nouveau = False
        Next
    Next
    RefreshEcr
    Iteration = 0
End Sub
Public Sub SaveFile()
On Error GoTo ErrSaveFile
    a = 0
    For X = 0 To UBound(Cells, 1)
        For Y = 0 To UBound(Cells, 2)
            If Cells(X, Y).Nouveau = True Then a = a + 1
        Next
    Next
    If a < 3 Then
        MsgBox "Pas assez de cellules actives pour pouvoir enregistrer.", vbExclamation, "Impossible d'enregistrer"
        Exit Sub
    End If
    
    a = InputBox("Entrez le nom de la sauvegarde.", "Enregistrer le tableau")
    If a = "" Then Exit Sub
    
    If Dir(App.Path + "\" + a + ".vie", vbArchive + vbHidden + vbReadOnly + vbSystem) <> "" Then
        If MsgBox("Fichier dj existant, voulez-vous le rcrire ?", vbQuestion + vbYesNo + vbDefaultButton2, "Sauvegarde existante") = vbNo Then Exit Sub
    End If
    
    If MsgBox("Voulez-vous enregistrer le fichier au format BMP ?", vbQuestion + vbYesNo + vbDefaultButton2, "Enregistrer") = vbNo Then
        If MsgBox("Voulez-vous compresser la sauvegarde ?", vbQuestion + vbYesNo, "Compression ?") = vbYes Then
            Ver = 2
        Else
            Ver = 1
        End If
        
    Dim Ecr As String * 1
    Dim Bin() As Byte
        Open App.Path + "\" + a + ".vie" For Output As #1: Close
        Open App.Path + "\" + a + ".vie" For Binary As #1
            ReDim Bin(0 To 12)
            Bin(0) = Asc("P")
            Bin(1) = Asc("r")
            Bin(2) = Asc("j")
            Bin(3) = Asc("V")
            Bin(4) = Asc("i")
            Bin(5) = Asc("e")
            Bin(6) = 0
            Bin(7) = Ver
            Bin(8) = Val("&h" + Left(Right("0000" + Hex(UBound(Cells, 1) + 1), 4), 2))
            Bin(9) = Val("&h" + Right(Right("0000" + Hex(UBound(Cells, 1) + 1), 4), 2))
            Bin(10) = Val("&h" + Left(Right("0000" + Hex(UBound(Cells, 2) + 1), 4), 2))
            Bin(11) = Val("&h" + Right(Right("0000" + Hex(UBound(Cells, 2) + 1), 4), 2))
            
            Bin(12) = 255
            For i = 0 To 11
                Bin(12) = Bin(12) Xor Bin(i)
            Next
            
            Seek #1, 1
            
            For i = 0 To 12
                Ecr = Chr(Bin(i))
                Put #1, , Ecr
            Next
            
            Lng = (UBound(Cells, 1) + 1) / 8
            If Lng <> Int(Lng) Then Lng = Int(Lng) + 1
            
            If Ver = 1 Then
                
                ReDim Bin(0 To Lng)
                
                For Y = 0 To UBound(Cells, 2)
                    b = ""
                    For i = 0 To UBound(Cells, 1)
                        b = b + Format(Abs(Cells(i, Y).Nouveau))
                    Next
                    Do While (Len(b) Mod 8) <> 0
                        b = b + "0"
                    Loop
                    
                    For i = 1 To Len(b) Step 8
                        a = 0
                        For j = 0 To 7
                            a = a * 2 + Val(Mid(b, i + j, 1))
                        Next
                        Bin(Int(i / 8)) = a
                    Next
                    
                    Bin(Lng) = 255
                    For i = 0 To UBound(Bin) - 1
                        Bin(Lng) = Bin(Lng) Xor Bin(i)
                    Next
                    
                    For i = 0 To UBound(Bin)
                        Ecr = Chr(Bin(i))
                        Put #1, , Ecr
                    Next
                Next
            ElseIf Ver = 2 Then
                a = ""
                For Y = 0 To UBound(Cells, 2)
                    z = ""
                    b = ""
                    For i = 0 To UBound(Cells, 1)
                        b = b + Format(Abs(Cells(i, Y).Nouveau))
                    Next
                    
                    nb = 0
                    Last = ""
                    For i = 1 To Len(b)
                        c = Mid(b, i, 1)
                        If c <> Last Then
                            If Last <> "" Then
                                nb = nb - 1
                                nb = nb * 2 + Val(Last)
                                z = z + Hex(nb)
                            End If
                            nb = 1
                            Last = c
                        Else
                            nb = nb + 1
                            If nb = 8 Then
                                nb = nb - 1
                                nb = nb * 2 + Val(Last)
                                z = z + Hex(nb)
                                nb = 0
                                Last = c
                            End If
                        End If
                    Next
                    
                    If nb > 0 Then
                        nb = nb - 1
                        nb = nb * 2 + Val(Last)
                        z = z + Hex(nb)
                    End If
                    
                    d = 15
                    For i = 1 To Len(z)
                        d = d Xor Val("&h" + Mid(z, i, 1))
                    Next
                    z = z + Hex(d)
                    
                    a = a + z
                    
                    Do While Len(a) >= 2
                        Ecr = Chr(Val("&h" + Left(a, 2)))
                        a = Right(a, Len(a) - 2)
                        Put #1, , Ecr
                    Loop
                Next
                If Len(a) > 0 Then
                    a = a + "0"
                    Ecr = Chr(Val("&h" + Left(a, 2)))
                    Put #1, , Ecr
                End If
            Else
                MsgBox "Erreur dans l'application, impossible d'enregistrer.", vbCritical, "Erreur fatale"
                Close
                End
            End If
        Else
Dim Pict As PictureBox
            Set Pict = FrmTaskBar.Pict
                Pict.Height = UBound(Cells, 2) + 1
                Pict.Width = UBound(Cells, 1) + 1
                
                For X = 0 To UBound(Cells, 1)
                    For Y = 0 To UBound(Cells, 2)
                        If Cells(X, Y).Nouveau = True Then
                            Pict.PSet (X, Y), RGB(255, 255, 255)
                        Else
                            Pict.PSet (X, Y), 0
                        End If
                    Next
                Next
                
                SavePicture Pict.Picture, App.Path + "\" + a + ".bmp"
            Set Pict = Nothing
        End If
ErrSaveFile:
    Close
    If Err <> 0 Then
        LogErr "SaveFile", Err, Erl
        MsgBox "Une erreur est survenue lors de la sauvegarde, le fichier est probablement endomag et inutilisable", vbExclamation, "Erreur"
    End If
    On Error GoTo 0
End Sub
Private Sub LoadBitmap(ByVal FileName As String)
Dim Pict As PictureBox
    Set Pict = FrmTaskBar.Pict
    Pict.Picture = LoadPicture(FileName)
        DoEvents
        ResizeTerrain Pict.Width, Pict.Height
        
        For X = 0 To UBound(Cells, 1)
            For Y = 0 To UBound(Cells, 2)
                If Pict.Point(X, Y) = 0 Then
                    Cells(X, Y).Nouveau = False
                Else
                    Cells(X, Y).Nouveau = True
                End If
            Next
        Next
        
        RefreshEcr
    Set Pict = Nothing
End Sub
Public Sub LoadFile()
On Local Error GoTo ErrLoadFile
    Moda = 0
    FrmLoadFile.Show 1
    Moda = 1
    a = FrmLoadFile.FileName
    Moda = 2
    Unload FrmLoadFile
    Moda = 3
    
    If a = "" Then Exit Sub
    
    If Dir(a, vbArchive + vbHidden + vbReadOnly + vbSystem) = "" Then GoTo ErrLoadFile
    
    If LCase(Right(a, 3)) = "bmp" Then LoadBitmap a: GoTo ErrLoadFile
    
    If LCase(Right(a, 3)) = "txt" Then
        Open a For Input As #1
            Input #1, X, Y
            ResizeTerrain X, Y
            Do Until EOF(1)
                Input #1, X, Y
                Cells(X, Y).Nouveau = True
            Loop
        Close #1
        RefreshEcr
        GoTo ErrLoadFile
    End If
    
Dim Ecr As String * 1
Dim Bin() As Byte
    Open a For Binary Access Read As #1
        Get #1, 8, Ecr
        If Ecr = Chr(1) Then
            ReDim Bin(0 To 12)
            Seek #1, 1
            
            For i = 0 To 12
                Get #1, , Ecr
                Bin(i) = Asc(Ecr)
            Next
            
            a = 255
            For i = 0 To 12
                a = a Xor Bin(i)
            Next
            If a <> 0 Then
                MsgBox "Entte du fichier corrompue, fichier non chargeable.", vbCritical, "Fichier corrupu"
                GoTo ErrLoadFile
            End If
            
            If Not (Bin(0) = Asc("P") Or Bin(1) = Asc("r") Or Bin(2) = Asc("j") Or Bin(3) = Asc("V") Or Bin(4) = Asc("i") Or Bin(5) = Asc("e") Or Bin(6) = 0) Then
                MsgBox "Fichier non destin  ce programme, chargement annul.", vbInformation, "Fichier"
                GoTo ErrLoadFile
            End If
            
            X1 = Bin(8) * 256 + Bin(9)
            Y1 = Bin(10) * 256 + Bin(11)
            
            ResizeTerrain X1, Y1
            
            b = X1 / 8
            If b <> Int(b) Then b = Int(b + 1)
            
            ReDim Bin(0 To b)
            
            For Y = 0 To Y1 - 1
                a = ""
                For i = 0 To UBound(Bin)
                    Get #1, , Ecr
                    Bin(i) = Asc(Ecr)
                Next
                
                b = 255
                For i = 0 To UBound(Bin)
                    b = b Xor Bin(i)
                Next
                If b <> 0 Then
                    MsgBox "La ligne n" + Format(Y + 1) + " est corrompue, poursuite du chargement.", vbInformation, "Ligne corrompue"
                End If
                
                For i = 0 To UBound(Bin) - 1
                    a = a + CnvDecBin(Bin(i))
                Next
                
                For X = 0 To X1 - 1
                    Cells(X, Y).Nouveau = (Mid(a, X + 1, 1) = "1")
                Next
            Next
        ElseIf Ecr = Chr(2) Then
            ReDim Bin(0 To 12)
            Seek #1, 1
            
            For i = 0 To 12
                Get #1, , Ecr
                Bin(i) = Asc(Ecr)
            Next
            
            a = 255
            For i = 0 To 12
                a = a Xor Bin(i)
            Next
            If a <> 0 Then
                MsgBox "Entte du fichier corrompue, fichier non chargeable.", vbCritical, "Fichier corrupu"
                GoTo ErrLoadFile
            End If
            
            If Not (Bin(0) = Asc("P") Or Bin(1) = Asc("r") Or Bin(2) = Asc("j") Or Bin(3) = Asc("V") Or Bin(4) = Asc("i") Or Bin(5) = Asc("e") Or Bin(6) = 0) Then
                MsgBox "Fichier non destin  ce programme, chargement annul.", vbInformation, "Fichier"
                GoTo ErrLoadFile
            End If
            
            X1 = Bin(8) * 256 + Bin(9)
            Y1 = Bin(10) * 256 + Bin(11)
            
            ResizeTerrain X1, Y1
            
            b = ""
            d = ""
            For Y = 0 To UBound(Cells, 2)
                a = ""
                
                Do While Len(a) < UBound(Cells, 1) + 1
                    Get #1, , Ecr
                    If (Len(b) Mod 2) = 1 Then
                        Do While Len(b) > 2
                            b = Right(b, 1)
                        Loop
                    Else
                        b = ""
                    End If
                    b = b + Right("00" + Hex(Asc(Ecr)), 2)
                    d = d + Right("00" + Hex(Asc(Ecr)), 2)
                    For i = 1 To Len(b)
                        c = Val("&h" + Mid(b, i, 1))
                        If (c And 1) = 1 Then
                            a = a + String(Int(c / 2) + 1, "1")
                        Else
                            a = a + String(Int(c / 2) + 1, "0")
                        End If
                    Next
                Loop
                
                crc = 0
                If Len(a) > UBound(Cells, 1) + 1 Then
                    a = Left(a, Len(a) - 4)
                    
                    d = Left(d, Len(d) - 1)
                    crc = Val("&h" + Right(b, 1))
                    
                    b = ""
'                    d = ""
                Else
                    Get #1, , Ecr
                    If Len(b) = 2 Then b = ""
                    b = b + Right("00" + Hex(Asc(Ecr)), 2)
                    crc = Val("&h" + Left(b, 1))
                    b = Right(b, 1)
                End If
                
                e = 15
                For i = 1 To Len(d)
                    e = e Xor Val("&h" + Mid(d, i, 1))
                Next
                
                If e <> crc Then
                    MsgBox "La ligne n" + Format(Y + 1) + " est corrompue, poursuite du chargement.", vbInformation, "Ligne corrompue"
                End If
                
                For X = 0 To UBound(Cells, 1)
                    Cells(X, Y).Nouveau = (Mid(a, X + 1, 1) = "1")
                Next
                d = b
            Next
'            b = X1 / 8
'            If b <> Int(b) Then b = Int(b + 1)
'
'            ReDim Bin(0 To b)
'
'            For Y = 0 To Y1 - 1
'                a = ""
'                For i = 0 To UBound(Bin)
'                    Get #1, , Ecr
'                    Bin(i) = Asc(Ecr)
'                Next
'
'                b = 255
'                For i = 0 To UBound(Bin)
'                    b = b Xor Bin(i)
'                Next
'                If b <> 0 Then
'                    MsgBox "La ligne n" + Format(Y + 1) + " est corrompue, poursuite du chargement.", vbInformation, "Ligne corrompue"
'                End If
'
'                For i = 0 To UBound(Bin) - 1
'                    a = a + CnvDecBin(Bin(i))
'                Next
'
'                For X = 0 To X1 - 1
'                    Cells(X, Y).Nouveau = (Mid(a, X + 1, 1) = "1")
'                Next
'            Next
        Else
            MsgBox "Version de fichier inconnue. Chargement impossible.", vbCritical, "Ouverture"
        End If
ErrLoadFile:
    Close
    If Moda = 1 Or Moda = 2 Then Unload FrmLoadFile
    If Err <> 0 Then
        MsgBox "Une erreur est survenue lors du chargement de la sauvegarde. Sauvegarde non charge.", vbExclamation, "Erreur"
    End If
    RefreshEcr
    FrmCmd.Timer1.Enabled = False
End Sub
Private Function CnvDecBin(ByVal Num As Byte, Optional ByVal NbBit As Long = 8) As String
    a = ""
    Do While Num > 0
        a = Format(Num Mod 2) + a
        Num = Int(Num / 2)
    Loop
    CnvDecBin = Right("00000000" + a, NbBit)
End Function
Public Sub ResizeTerrain(ByVal X As Long, ByVal Y As Long)
    ReDim Cells(0 To Val(X) - 1, 0 To Val(Y) - 1)
    ControlSize
End Sub
Public Sub ControlSize()
    X = UBound(Cells, 1) + 1
    Y = UBound(Cells, 2) + 1
    If MdlPublic.XLoupe + MdlPublic.XMaxLoupe > X - 1 Then
        MdlPublic.XLoupe = MdlPublic.XMaxLoupe - (X - 1)
    End If
    If MdlPublic.YLoupe + MdlPublic.YMaxLoupe > Y - 1 Then
        MdlPublic.YLoupe = MdlPublic.YMaxLoupe - (Y - 1)
    End If
    
    Do While FrmLarge.ScaleHeight > UBound(Cells, 2)
        a = FrmLarge.Height
        FrmLarge.Height = FrmLarge.Height - Screen.TwipsPerPixelY
        If FrmLarge.Height = a Then Exit Do
    Loop
    Do While FrmLarge.ScaleHeight < UBound(Cells, 2)
        a = FrmLarge.Height
        FrmLarge.Height = FrmLarge.Height + Screen.TwipsPerPixelY
        If FrmLarge.Height = a Then Exit Do
    Loop
    Do While FrmLarge.ScaleWidth > UBound(Cells, 1)
        a = FrmLarge.Width
        FrmLarge.Width = FrmLarge.Width - Screen.TwipsPerPixelX
        If FrmLarge.Width = a Then Exit Do
    Loop
    Do While FrmLarge.ScaleWidth < UBound(Cells, 1)
        a = FrmLarge.Width
        FrmLarge.Width = FrmLarge.Width + Screen.TwipsPerPixelX
        If FrmLarge.Width = a Then Exit Do
    Loop
    
    FrmCmd.TxtDimX = UBound(Cells, 1) + 1
    FrmCmd.TxtDimY = UBound(Cells, 2) + 1
    
    FrmLarge.Sh.Top = YLoupe
    FrmLarge.Sh.Left = XLoupe
    FrmLarge.Sh.Height = YMaxLoupe
    FrmLarge.Sh.Width = XMaxLoupe
End Sub
Public Sub ActiveForm(ByRef Frm As Form)
    Set FormAct = Frm
End Sub
Public Sub RestoreActiveForm()
    FormAct.Show
End Sub
